Index: /palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 2232)
@@ -2444,14 +3054,21 @@
           i = nxl - 1
           DO  j = nysg, nyng
-             DO  k = nzb_s_inner(j,i) + 1, nzt
+             k_wall = MAXLOC(                                                  &
+                          MERGE( 1, 0,                                         &
+                                 BTEST( wall_flags_0(nzb:nzb_max,j,i), 12 )    &
+                               ), DIM = 1                                      &
+                            ) - 1
+
+             DO  k = k_wall + 1, nzt
+
                 kc     = kco(k+1)
                 glsf   = ( dx * dy * dzu(k) )**p13
                 glsc   = ( cg%dx * cg%dy *cg%dzu(kc) )**p13
-                height = zu(k) - zu(nzb_s_inner(j,i))
+                height = zu(k) - zu(k_wall)
                 fw     = EXP( -cfw * height / glsf )
                 tkefactor_l(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *      &
                                               ( glsf / glsc )**p23 )
              ENDDO
-             tkefactor_l(nzb_s_inner(j,i),j) = c_tkef * fw0
+             tkefactor_l(k_wall,j) = c_tkef * fw0
           ENDDO
        ENDIF
@@ -2462,14 +3079,21 @@
           i = nxr + 1
           DO  j = nysg, nyng
-             DO  k = nzb_s_inner(j,i) + 1, nzt
+             k_wall = MAXLOC(                                                  &
+                          MERGE( 1, 0,                                         &
+                                 BTEST( wall_flags_0(nzb:nzb_max,j,i), 12 )    &
+                               ), DIM = 1                                      &
+                            ) - 1
+
+             DO  k = k_wall + 1, nzt
+
                 kc     = kco(k+1)
                 glsf   = ( dx * dy * dzu(k) )**p13
                 glsc   = ( cg%dx * cg%dy * cg%dzu(kc) )**p13
-                height = zu(k) - zu(nzb_s_inner(j,i))
+                height = zu(k) - zu(k_wall)
                 fw     = EXP( -cfw * height / glsf )
                 tkefactor_r(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *      &
                                               ( glsf / glsc )**p23 )
              ENDDO
-             tkefactor_r(nzb_s_inner(j,i),j) = c_tkef * fw0
+             tkefactor_r(k_wall,j) = c_tkef * fw0
           ENDDO
        ENDIF
@@ -2480,14 +3104,21 @@
           j = nys - 1
           DO  i = nxlg, nxrg
-             DO  k = nzb_s_inner(j,i) + 1, nzt
+             k_wall = MAXLOC(                                                  &
+                          MERGE( 1, 0,                                         &
+                                 BTEST( wall_flags_0(nzb:nzb_max,j,i), 12 )    &
+                               ), DIM = 1                                      &
+                            ) - 1
+
+             DO  k = k_wall + 1, nzt
+
                 kc     = kco(k+1)
                 glsf   = ( dx * dy * dzu(k) )**p13
                 glsc   = ( cg%dx * cg%dy * cg%dzu(kc) ) ** p13
-                height = zu(k) - zu(nzb_s_inner(j,i))
+                height = zu(k) - zu(k_wall)
                 fw     = EXP( -cfw*height / glsf )
                 tkefactor_s(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *      &
                                               ( glsf / glsc )**p23 )
              ENDDO
-             tkefactor_s(nzb_s_inner(j,i),i) = c_tkef * fw0
+             tkefactor_s(k_wall,i) = c_tkef * fw0
           ENDDO
        ENDIF
@@ -2498,14 +3129,20 @@
           j = nyn + 1
           DO  i = nxlg, nxrg
-             DO  k = nzb_s_inner(j,i)+1, nzt
+             k_wall = MAXLOC(                                                  &
+                          MERGE( 1, 0,                                         &
+                                 BTEST( wall_flags_0(nzb:nzb_max,j,i), 12 )    &
+                               ), DIM = 1                                      &
+                            ) - 1
+             DO  k = k_wall + 1, nzt
+
                 kc     = kco(k+1)
                 glsf   = ( dx * dy * dzu(k) )**p13
                 glsc   = ( cg%dx * cg%dy * cg%dzu(kc) )**p13
-                height = zu(k) - zu(nzb_s_inner(j,i))
+                height = zu(k) - zu(k_wall)
                 fw     = EXP( -cfw * height / glsf )
-                tkefactor_n(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *      &
+                tkefactor_n(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *     &
                                               ( glsf / glsc )**p23 )
              ENDDO
-             tkefactor_n(nzb_s_inner(j,i),i) = c_tkef * fw0
+             tkefactor_n(k_wall,i) = c_tkef * fw0
           ENDDO
        ENDIF
@@ -2513,12 +3150,21 @@
        ALLOCATE( tkefactor_t(nysg:nyng,nxlg:nxrg) )
        k = nzt
+
        DO  i = nxlg, nxrg
           DO  j = nysg, nyng
+!
+!--          Determine vertical index for local topography top
+             k_wall = MAXLOC(                                                  &
+                        MERGE( 1, 0,                                           &
+                               BTEST( wall_flags_0(nzb:nzb_max,j,i), 12 )      &
+                             ), DIM = 1                                        &
+                            ) - 1
+
              kc     = kco(k+1)
              glsf   = ( dx * dy * dzu(k) )**p13
              glsc   = ( cg%dx * cg%dy * cg%dzu(kc) )**p13
-             height = zu(k) - zu(nzb_s_inner(j,i))
+             height = zu(k) - zu(k_wall)
              fw     = EXP( -cfw * height / glsf )
-             tkefactor_t(j,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *         &
+             tkefactor_t(j,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *        &
                                            ( glsf / glsc )**p23 )
           ENDDO
@@ -2783,4 +3429,5 @@
     INTEGER(iwp) ::  jcn        !:
     INTEGER(iwp) ::  jcs        !:
+    INTEGER(iwp) ::  k          !:
 
     REAL(wp) ::  waittime       !:
@@ -2804,15 +3451,15 @@
 !--    The interpolation.
        CALL pmci_interp_tril_all ( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,    &
-                                   r2yo, r1zo, r2zo, nzb_u_inner, 'u' )
+                                   r2yo, r1zo, r2zo, 'u' )
        CALL pmci_interp_tril_all ( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,    &
-                                   r2yv, r1zo, r2zo, nzb_v_inner, 'v' )
+                                   r2yv, r1zo, r2zo, 'v' )
        CALL pmci_interp_tril_all ( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,    &
-                                   r2yo, r1zw, r2zw, nzb_w_inner, 'w' )
+                                   r2yo, r1zw, r2zw, 'w' )
        CALL pmci_interp_tril_all ( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,    &
-                                   r2yo, r1zo, r2zo, nzb_s_inner, 'e' )
+                                   r2yo, r1zo, r2zo, 'e' )
 
        IF ( .NOT. neutral )  THEN
           CALL pmci_interp_tril_all ( pt, ptc, ico, jco, kco, r1xo, r2xo,       &
-                                      r1yo, r2yo, r1zo, r2zo, nzb_s_inner, 's' )
+                                      r1yo, r2yo, r1zo, r2zo, 's' )
        ENDIF
 
@@ -2820,19 +3467,15 @@
 
           CALL pmci_interp_tril_all ( q, q_c, ico, jco, kco, r1xo, r2xo, r1yo,   &
-                                      r2yo, r1zo, r2zo, nzb_s_inner, 's' )
+                                      r2yo, r1zo, r2zo, 's' )
 
           IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
 !              CALL pmci_interp_tril_all ( qc, qcc, ico, jco, kco, r1xo, r2xo,    &
-!                                          r1yo, r2yo, r1zo, r2zo, nzb_s_inner,   & 
-!                                          's' ) 
+!                                          r1yo, r2yo, r1zo, r2zo, 's' ) 
              CALL pmci_interp_tril_all ( qr, qrc, ico, jco, kco, r1xo, r2xo,    &
-                                         r1yo, r2yo, r1zo, r2zo, nzb_s_inner,   & 
-                                         's' )
+                                         r1yo, r2yo, r1zo, r2zo, 's' )
 !             CALL pmci_interp_tril_all ( nc, ncc, ico, jco, kco, r1xo, r2xo,    &
-!                                         r1yo, r2yo, r1zo, r2zo, nzb_s_inner,   & 
-!                                         's' )   
+!                                         r1yo, r2yo, r1zo, r2zo, 's' )   
              CALL pmci_interp_tril_all ( nr, nrc, ico, jco, kco, r1xo, r2xo,    &
-                                         r1yo, r2yo, r1zo, r2zo, nzb_s_inner,   & 
-                                         's' )
+                                         r1yo, r2yo, r1zo, r2zo, 's' )
           ENDIF
 
@@ -2841,5 +3484,5 @@
        IF ( passive_scalar )  THEN
           CALL pmci_interp_tril_all ( s, sc, ico, jco, kco, r1xo, r2xo, r1yo,   &
-                                      r2yo, r1zo, r2zo, nzb_s_inner, 's' )
+                                      r2yo, r1zo, r2zo, 's' )
        ENDIF
 
@@ -2851,12 +3494,22 @@
           DO   i = nxlg, nxrg
              DO   j = nysg, nyng
-                u(nzb:nzb_u_inner(j,i),j,i)   = 0.0_wp
-                v(nzb:nzb_v_inner(j,i),j,i)   = 0.0_wp
-                w(nzb:nzb_w_inner(j,i),j,i)   = 0.0_wp
-                e(nzb:nzb_s_inner(j,i),j,i)   = 0.0_wp
-                u_p(nzb:nzb_u_inner(j,i),j,i) = 0.0_wp
-                v_p(nzb:nzb_v_inner(j,i),j,i) = 0.0_wp
-                w_p(nzb:nzb_w_inner(j,i),j,i) = 0.0_wp
-                e_p(nzb:nzb_s_inner(j,i),j,i) = 0.0_wp
+                DO  k = nzb, nzt
+                   u(k,j,i)   = MERGE( u(k,j,i), 0.0_wp,                       &
+                                       BTEST( wall_flags_0(k,j,i), 1 ) )
+                   v(k,j,i)   = MERGE( v(k,j,i), 0.0_wp,                       &
+                                       BTEST( wall_flags_0(k,j,i), 2 ) )
+                   w(k,j,i)   = MERGE( w(k,j,i), 0.0_wp,                       &
+                                       BTEST( wall_flags_0(k,j,i), 3 ) )
+                   e(k,j,i)   = MERGE( e(k,j,i), 0.0_wp,                       &
+                                       BTEST( wall_flags_0(k,j,i), 0 ) )
+                   u_p(k,j,i) = MERGE( u_p(k,j,i), 0.0_wp,                     &
+                                       BTEST( wall_flags_0(k,j,i), 1 ) )
+                   v_p(k,j,i) = MERGE( v_p(k,j,i), 0.0_wp,                     &
+                                       BTEST( wall_flags_0(k,j,i), 2 ) )
+                   w_p(k,j,i) = MERGE( w_p(k,j,i), 0.0_wp,                     &
+                                       BTEST( wall_flags_0(k,j,i), 3 ) )
+                   e_p(k,j,i) = MERGE( e_p(k,j,i), 0.0_wp,                     &
+                                       BTEST( wall_flags_0(k,j,i), 0 ) )
+                ENDDO
              ENDDO
           ENDDO
@@ -2869,5 +3522,5 @@
 
     SUBROUTINE pmci_interp_tril_all( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y,     &
-                                     r1z, r2z, kb, var )
+                                     r1z, r2z, var )
 !
 !--    Interpolation of the internal values for the child-domain initialization
@@ -2881,18 +3534,20 @@
        INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN)           ::  jc    !:
        INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc    !:
-       INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN) ::  kb    !:
-
-       INTEGER(iwp) ::  i      !:
-       INTEGER(iwp) ::  ib     !:
-       INTEGER(iwp) ::  ie     !:
-       INTEGER(iwp) ::  j      !:
-       INTEGER(iwp) ::  jb     !:
-       INTEGER(iwp) ::  je     !:
-       INTEGER(iwp) ::  k      !:
-       INTEGER(iwp) ::  k1     !:
-       INTEGER(iwp) ::  kbc    !:
-       INTEGER(iwp) ::  l      !:
-       INTEGER(iwp) ::  m      !:
-       INTEGER(iwp) ::  n      !:
+
+       INTEGER(iwp) ::  flag_nr  !: Number of flag array to mask topography on respective u/v/w or s grid
+       INTEGER(iwp) ::  flag_nr2 !: Number of flag array to indicate vertical index of topography top on respective u/v/w or s grid
+       INTEGER(iwp) ::  i        !:
+       INTEGER(iwp) ::  ib       !:
+       INTEGER(iwp) ::  ie       !:
+       INTEGER(iwp) ::  j        !:
+       INTEGER(iwp) ::  jb       !:
+       INTEGER(iwp) ::  je       !:
+       INTEGER(iwp) ::  k        !:
+       INTEGER(iwp) ::  k_wall   !:
+       INTEGER(iwp) ::  k1       !:
+       INTEGER(iwp) ::  kbc      !:
+       INTEGER(iwp) ::  l        !:
+       INTEGER(iwp) ::  m        !:
+       INTEGER(iwp) ::  n        !:
 
        REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) :: f !:
@@ -2914,4 +3569,5 @@
        REAL(wp) ::  logzuc1    !:
        REAL(wp) ::  zuc1       !:
+       REAL(wp) ::  z0_topo    !:  roughness at vertical walls
 
 
@@ -2945,8 +3601,23 @@
        ENDIF
 !
+!--    Determine number of flag array to be used to mask topography
+       IF ( var == 'u' )  THEN
+          flag_nr  = 1
+          flag_nr2 = 14
+       ELSEIF ( var == 'v' )  THEN
+          flag_nr  = 2
+          flag_nr2 = 16
+       ELSEIF ( var == 'w' )  THEN
+          flag_nr  = 3
+          flag_nr2 = 18
+       ELSE
+          flag_nr  = 0
+          flag_nr2 = 12
+       ENDIF
+!
 !--    Trilinear interpolation.
        DO  i = ib, ie
           DO  j = jb, je
-             DO  k = kb(j,i), nzt + 1
+             DO  k = nzb, nzt + 1
                 l = ic(i)
                 m = jc(j)
@@ -2970,27 +3641,35 @@
 !--    too.
        IF ( var == 'u' .OR. var == 'v' )  THEN
+          z0_topo = roughness_length
           DO  i = ib, nxr
              DO  j = jb, nyn
+!
+!--             Determine vertical index of topography top at grid point (j,i)
+                k_wall = MAXLOC(                                               &
+                      MERGE( 1, 0,                                             &
+                             BTEST( wall_flags_0(nzb:nzb_max,j,i), flag_nr2 )  &
+                           ), DIM = 1                                          &
+                               ) - 1
+!
+!--             kbc is the first coarse-grid point above the surface
                 kbc = 1
-!
-!--             kbc is the first coarse-grid point above the surface
-                DO  WHILE ( cg%zu(kbc) < zu(kb(j,i)) )
+                DO  WHILE ( cg%zu(kbc) < zu(k_wall) )
                    kbc = kbc + 1
                 ENDDO
                 zuc1 = cg%zu(kbc)
-                k1   = kb(j,i) + 1
+                k1   = k_wall + 1
                 DO  WHILE ( zu(k1) < zuc1 )
                    k1 = k1 + 1
                 ENDDO
-                logzuc1 = LOG( ( zu(k1) - zu(kb(j,i)) ) / z0(j,i) )
-
-                k = kb(j,i) + 1
+                logzuc1 = LOG( ( zu(k1) - zu(k_wall) ) / z0_topo )
+
+                k = k_wall + 1
                 DO  WHILE ( zu(k) < zuc1 )
-                   logratio = ( LOG( ( zu(k) - zu(kb(j,i)) ) / z0(j,i)) ) /     &
+                   logratio = ( LOG( ( zu(k) - zu(k_wall) ) / z0_topo ) ) /     &
                                 logzuc1
                    f(k,j,i) = logratio * f(k1,j,i)
                    k  = k + 1
                 ENDDO
-                f(kb(j,i),j,i) = 0.0_wp
+                f(k_wall,j,i) = 0.0_wp
              ENDDO
           ENDDO
@@ -3000,7 +3679,15 @@
           DO  i = ib, nxr
               DO  j = jb, nyn
-                f(kb(j,i),j,i) = 0.0_wp
-             ENDDO
-          ENDDO
+!
+!--              Determine vertical index of topography top at grid point (j,i)
+                 k_wall = MAXLOC(                                              &
+                      MERGE( 1, 0,                                             &
+                             BTEST( wall_flags_0(nzb:nzb_max,j,i), flag_nr2 )  &
+                           ), DIM = 1                                          &
+                                ) - 1
+
+                 f(k_wall,j,i) = 0.0_wp
+              ENDDO
+           ENDDO
 
        ENDIF
@@ -3137,6 +3824,8 @@
        innor = dy
        DO   j = nys, nyn
-          DO   k = nzb_u_inner(j,i)+1, nzt
-             volume_flow_l(1) = volume_flow_l(1) + innor * u(k,j,i) * dzw(k)
+          DO   k = nzb+1, nzt
+             volume_flow_l(1) = volume_flow_l(1) + innor * u(k,j,i) * dzw(k)   &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,i), 1 ) )
           ENDDO
        ENDDO
@@ -3147,6 +3836,8 @@
        innor = -dy
        DO   j = nys, nyn
-          DO   k = nzb_u_inner(j,i)+1, nzt
-             volume_flow_l(1) = volume_flow_l(1) + innor * u(k,j,i) * dzw(k)
+          DO   k = nzb+1, nzt
+             volume_flow_l(1) = volume_flow_l(1) + innor * u(k,j,i) * dzw(k)   &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,i), 1 ) )
           ENDDO
        ENDDO
@@ -3170,6 +3861,8 @@
        innor = dx
        DO   i = nxl, nxr
-          DO   k = nzb_v_inner(j,i)+1, nzt
-             volume_flow_l(2) = volume_flow_l(2) + innor * v(k,j,i) * dzw(k)
+          DO   k = nzb+1, nzt
+             volume_flow_l(2) = volume_flow_l(2) + innor * v(k,j,i) * dzw(k)   &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,i), 2 ) )
           ENDDO
        ENDDO
@@ -3180,6 +3873,8 @@
        innor = -dx
        DO   i = nxl, nxr
-          DO   k = nzb_v_inner(j,i)+1, nzt
-             volume_flow_l(2) = volume_flow_l(2) + innor * v(k,j,i) * dzw(k)
+          DO   k = nzb+1, nzt
+             volume_flow_l(2) = volume_flow_l(2) + innor * v(k,j,i) * dzw(k)   &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,i), 2 ) )
           ENDDO
        ENDDO
@@ -3340,6 +4035,7 @@
     INTEGER(iwp) ::  child_id    !:
     INTEGER(iwp) ::  i           !:
+    INTEGER(iwp) ::  ierr        !:
     INTEGER(iwp) ::  j           !:
-    INTEGER(iwp) ::  ierr        !:
+    INTEGER(iwp) ::  k           !:
     INTEGER(iwp) ::  m           !:
 
@@ -3374,8 +4070,13 @@
              DO   i = nxlg, nxrg
                 DO   j = nysg, nyng
-                   u(nzb:nzb_u_inner(j,i),j,i)  = 0.0_wp
-                   v(nzb:nzb_v_inner(j,i),j,i)  = 0.0_wp
-                   w(nzb:nzb_w_inner(j,i),j,i)  = 0.0_wp
-                   e(nzb:nzb_s_inner(j,i),j,i)  = 0.0_wp
+                   DO  k = nzb, nzt+1
+                      u(k,j,i)  = MERGE( u(k,j,i), 0.0_wp,                     &
+                                         BTEST( wall_flags_0(k,j,i), 1 ) )
+                      v(k,j,i)  = MERGE( v(k,j,i), 0.0_wp,                     &
+                                         BTEST( wall_flags_0(k,j,i), 2 ) )
+                      w(k,j,i)  = MERGE( w(k,j,i), 0.0_wp,                     &
+                                         BTEST( wall_flags_0(k,j,i), 3 ) )
+                      e(k,j,i)  = MERGE( e(k,j,i), 0.0_wp,                     &
+                                         BTEST( wall_flags_0(k,j,i), 0 ) )
 !
 !--                TO_DO: zero setting of temperature within topography creates
@@ -3385,4 +4086,5 @@
 !                      q(nzb:nzb_s_inner(j,i),j,i) = 0.0_wp
 !                   ENDIF
+                   ENDDO
                 ENDDO
              ENDDO
@@ -3463,20 +4165,20 @@
           IF ( nest_bound_l )  THEN
              CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu,      &
-                                       r1yo, r2yo, r1zo, r2zo, nzb_u_inner,     &
+                                       r1yo, r2yo, r1zo, r2zo,                  &
                                        logc_u_l, logc_ratio_u_l,                &
                                        nzt_topo_nestbc_l, 'l', 'u' )
 
              CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo,      &
-                                       r1yv, r2yv, r1zo, r2zo, nzb_v_inner,     &
+                                       r1yv, r2yv, r1zo, r2zo,                  &
                                        logc_v_l, logc_ratio_v_l,                &
                                        nzt_topo_nestbc_l, 'l', 'v' )
 
              CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo,      &
-                                       r1yo, r2yo, r1zw, r2zw, nzb_w_inner,     &
+                                       r1yo, r2yo, r1zw, r2zw,                  &
                                        logc_w_l, logc_ratio_w_l,                &
                                        nzt_topo_nestbc_l, 'l', 'w' )
 
              CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,      &
-                                       r1yo, r2yo, r1zo, r2zo, nzb_s_inner,     &
+                                       r1yo, r2yo, r1zo, r2zo,                  &
                                        logc_u_l, logc_ratio_u_l,                &
                                        nzt_topo_nestbc_l, 'l', 'e' )
@@ -3484,5 +4186,5 @@
              IF ( .NOT. neutral )  THEN
                 CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo,   &
-                                          r1yo, r2yo, r1zo, r2zo, nzb_s_inner,  &
+                                          r1yo, r2yo, r1zo, r2zo,               &
                                           logc_u_l, logc_ratio_u_l,             &
                                           nzt_topo_nestbc_l, 'l', 's' )
@@ -3492,5 +4194,5 @@
 
                 CALL pmci_interp_tril_lr( q, q_c, ico, jco, kco, r1xo, r2xo,    &
-                                          r1yo, r2yo, r1zo, r2zo, nzb_s_inner,  &
+                                          r1yo, r2yo, r1zo, r2zo,               &
                                           logc_u_l, logc_ratio_u_l,             &
                                           nzt_topo_nestbc_l, 'l', 's' )
@@ -3500,5 +4202,5 @@
 !                    CALL pmci_interp_tril_lr( qc, qcc, ico, jco, kco, r1xo, r2xo,&
 !                                              r1yo, r2yo, r1zo, r2zo,            &
-!                                              nzb_s_inner, logc_u_l,             &
+!                                              logc_u_l,                          &
 !                                              logc_ratio_u_l, nzt_topo_nestbc_l, &
 !                                              'l', 's' )  
@@ -3506,5 +4208,5 @@
                    CALL pmci_interp_tril_lr( qr, qrc, ico, jco, kco, r1xo, r2xo,&
                                              r1yo, r2yo, r1zo, r2zo,            &
-                                             nzb_s_inner, logc_u_l,             &
+                                             logc_u_l,                          &
                                              logc_ratio_u_l, nzt_topo_nestbc_l, &
                                              'l', 's' ) 
@@ -3512,5 +4214,5 @@
 !                    CALL pmci_interp_tril_lr( nc, ncc, ico, jco, kco, r1xo, r2xo,&
 !                                              r1yo, r2yo, r1zo, r2zo,            &
-!                                              nzb_s_inner, logc_u_l,             &
+!                                              logc_u_l,                          &
 !                                              logc_ratio_u_l, nzt_topo_nestbc_l, &
 !                                              'l', 's' ) 
@@ -3518,5 +4220,5 @@
                    CALL pmci_interp_tril_lr( nr, nrc, ico, jco, kco, r1xo, r2xo,&
                                              r1yo, r2yo, r1zo, r2zo,            &
-                                             nzb_s_inner, logc_u_l,             &
+                                             logc_u_l,                          &
                                              logc_ratio_u_l, nzt_topo_nestbc_l, &
                                              'l', 's' )             
@@ -3527,5 +4229,5 @@
              IF ( passive_scalar )  THEN
                 CALL pmci_interp_tril_lr( s, sc, ico, jco, kco, r1xo, r2xo,     &
-                                          r1yo, r2yo, r1zo, r2zo, nzb_s_inner,  &
+                                          r1yo, r2yo, r1zo, r2zo,               &
                                           logc_u_l, logc_ratio_u_l,             &
                                           nzt_topo_nestbc_l, 'l', 's' )
@@ -3533,24 +4235,22 @@
 
              IF ( TRIM( nesting_mode ) == 'one-way' )  THEN
-
-                CALL pmci_extrap_ifoutflow_lr( u, nzb_u_inner, 'l', 'u' )
-                CALL pmci_extrap_ifoutflow_lr( v, nzb_v_inner, 'l', 'v' )
-                CALL pmci_extrap_ifoutflow_lr( w, nzb_w_inner, 'l', 'w' )
-                CALL pmci_extrap_ifoutflow_lr( e, nzb_s_inner, 'l', 'e' )
+                CALL pmci_extrap_ifoutflow_lr( u, 'l', 'u' )
+                CALL pmci_extrap_ifoutflow_lr( v, 'l', 'v' )
+                CALL pmci_extrap_ifoutflow_lr( w, 'l', 'w' )
+                CALL pmci_extrap_ifoutflow_lr( e, 'l', 'e' )
 
                 IF ( .NOT. neutral )  THEN
-                   CALL pmci_extrap_ifoutflow_lr( pt,nzb_s_inner, 'l', 's' )
+                   CALL pmci_extrap_ifoutflow_lr( pt, 'l', 's' )
                 ENDIF
 
                 IF ( humidity )  THEN
-
-                   CALL pmci_extrap_ifoutflow_lr( q, nzb_s_inner, 'l', 's' )
+                   CALL pmci_extrap_ifoutflow_lr( q, 'l', 's' )
 
                    IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
 
-!                       CALL pmci_extrap_ifoutflow_lr( qc, nzb_s_inner, 'l', 's' )
-                      CALL pmci_extrap_ifoutflow_lr( qr, nzb_s_inner, 'l', 's' )
-!                      CALL pmci_extrap_ifoutflow_lr( nc, nzb_s_inner, 'l', 's' )
-                      CALL pmci_extrap_ifoutflow_lr( nr, nzb_s_inner, 'l', 's' )
+!                       CALL pmci_extrap_ifoutflow_lr( qc, 'l', 's' )
+                      CALL pmci_extrap_ifoutflow_lr( qr, 'l', 's' )
+!                      CALL pmci_extrap_ifoutflow_lr( nc, 'l', 's' )
+                      CALL pmci_extrap_ifoutflow_lr( nr, 'l', 's' )
 
                    ENDIF
@@ -3559,5 +4259,5 @@
 
                 IF ( passive_scalar )  THEN
-                   CALL pmci_extrap_ifoutflow_lr( s, nzb_s_inner, 'l', 's' )
+                   CALL pmci_extrap_ifoutflow_lr( s, 'l', 's' )
                 ENDIF
 
@@ -3569,38 +4269,39 @@
    !--    Right border pe
           IF ( nest_bound_r )  THEN
-
-             CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu,     &
-                                       r1yo, r2yo, r1zo, r2zo, nzb_u_inner,    &
-                                       logc_u_r, logc_ratio_u_r,               &
+             CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu,      &
+                                       r1yo, r2yo, r1zo, r2zo,                  &
+                                       logc_u_r, logc_ratio_u_r,                &
                                        nzt_topo_nestbc_r, 'r', 'u' )
 
-             CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo,     &
-                                       r1yv, r2yv, r1zo, r2zo, nzb_v_inner,    &
-                                       logc_v_r, logc_ratio_v_r,               &
+             CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo,      &
+                                       r1yv, r2yv, r1zo, r2zo,                  &
+                                       logc_v_r, logc_ratio_v_r,                &
                                        nzt_topo_nestbc_r, 'r', 'v' )
 
-             CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo,     &
-                                       r1yo, r2yo, r1zw, r2zw, nzb_w_inner,    &
-                                       logc_w_r, logc_ratio_w_r,               &
+             CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo,      &
+                                       r1yo, r2yo, r1zw, r2zw,                  &
+                                       logc_w_r, logc_ratio_w_r,                &
                                        nzt_topo_nestbc_r, 'r', 'w' )
 
-             CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,     &
-                                       r1yo,r2yo, r1zo, r2zo, nzb_s_inner,     &
-                                       logc_u_r, logc_ratio_u_r,               &
+             CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,      &
+                                       r1yo,r2yo, r1zo, r2zo,                   &
+                                       logc_u_r, logc_ratio_u_r,                &
                                        nzt_topo_nestbc_r, 'r', 'e' )
 
+
              IF ( .NOT. neutral )  THEN
-                CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo,  &
-                                          r1yo, r2yo, r1zo, r2zo, nzb_s_inner, &
-                                          logc_u_r, logc_ratio_u_r,            &
+                CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo,   &
+                                          r1yo, r2yo, r1zo, r2zo,               &
+                                          logc_u_r, logc_ratio_u_r,             &
                                           nzt_topo_nestbc_r, 'r', 's' )
+
              ENDIF
 
              IF ( humidity )  THEN
-
-                CALL pmci_interp_tril_lr( q, q_c, ico, jco, kco, r1xo, r2xo,   &
-                                          r1yo, r2yo, r1zo, r2zo, nzb_s_inner, &
-                                          logc_u_r, logc_ratio_u_r,            &
+                CALL pmci_interp_tril_lr( q, q_c, ico, jco, kco, r1xo, r2xo,    &
+                                          r1yo, r2yo, r1zo, r2zo,               &
+                                          logc_u_r, logc_ratio_u_r,             &
                                           nzt_topo_nestbc_r, 'r', 's' )
+
 
                 IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
@@ -3608,5 +4309,5 @@
 !                    CALL pmci_interp_tril_lr( qc, qcc, ico, jco, kco, r1xo,     &
 !                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
-!                                              nzb_s_inner, logc_u_r,            &
+!                                              logc_u_r,                         &
 !                                              logc_ratio_u_r, nzt_topo_nestbc_r,&
 !                                              'r', 's' ) 
@@ -3614,5 +4315,5 @@
                    CALL pmci_interp_tril_lr( qr, qrc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
-                                             nzb_s_inner, logc_u_r,            &
+                                             logc_u_r,                         &
                                              logc_ratio_u_r, nzt_topo_nestbc_r,&
                                              'r', 's' ) 
@@ -3620,5 +4321,5 @@
 !                    CALL pmci_interp_tril_lr( nc, ncc, ico, jco, kco, r1xo,     &
 !                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
-!                                              nzb_s_inner, logc_u_r,            &
+!                                              logc_u_r,                         &
 !                                              logc_ratio_u_r, nzt_topo_nestbc_r,&
 !                                              'r', 's' ) 
